package kaysaar.aotd_question_of_loyalty.data.models;

import kaysaar.aotd_question_of_loyalty.data.tags.AoTDRankTags;
import java.util.Iterator;
import java.util.Set;

public class RankData
{
    public String id;
    public String name;
    boolean isLeavingAnOption;
    float penaltyForLeaving;
    String description;
    int pointsOfObligation;
    public int points;
    public int salary;
    int amountOfColoniesAbleToColonize;
    boolean unRestrictedColonization;
    float tarrifReduciton;
    public Set<String> tags;
    
    public String getId() {
        return this.id;
    }
    
    public void setId(final String id) {
        this.id = id;
    }
    
    public String getName() {
        return this.name;
    }
    
    public void setName(final String name) {
        this.name = name;
    }
    
    public boolean isLeavingAnOption() {
        return true;
    }
    
    public void setLeavingAnOption(final boolean leavingAnOption) {
        this.isLeavingAnOption = leavingAnOption;
    }
    
    public float getPenaltyForLeaving() {
        return this.penaltyForLeaving;
    }
    
    public void setPenaltyForLeaving(final float penaltyForLeaving) {
        this.penaltyForLeaving = penaltyForLeaving;
    }
    
    public String getDescription() {
        return this.description;
    }
    
    public void setDescription(final String description) {
        this.description = description;
    }
    
    public int getPointsOfObligation() {
        return this.pointsOfObligation;
    }
    
    public void setPointsOfObligation(final int pointsOfObligation) {
        this.pointsOfObligation = pointsOfObligation;
    }
    
    public RankData(final String id, final String name, final boolean canLeaveWhenAttainedThisRank, final float penaltyforLeaving, final String description, final int pointsOfObligation, final int salary, final float tarrifReduciton, final Set<String> set, final int amountOfColoniesAbleToColonize) {
        this.id = id;
        this.name = name;
        this.isLeavingAnOption = canLeaveWhenAttainedThisRank;
        this.penaltyForLeaving = penaltyforLeaving;
        this.description = description;
        this.pointsOfObligation = pointsOfObligation;
        this.salary = salary;
        this.tags = set;
        this.unRestrictedColonization = false;
        this.amountOfColoniesAbleToColonize = amountOfColoniesAbleToColonize;
        this.tarrifReduciton = tarrifReduciton;
    }
    
    public boolean hasTag(final String tag) {
        for (final String s : this.tags) {
            if (s.equals(tag)) {
                return true;
            }
        }
        return false;
    }
    
    public float getTarrifReduciton() {
        return this.tarrifReduciton;
    }
    
    public int getAmountOfColoniesAbleToColonize() {
        return this.amountOfColoniesAbleToColonize;
    }
    
    public boolean isUnRestrictedColonization() {
        return this.tags.contains(AoTDRankTags.NONRESTRICTIVE_COLONIZATION);
    }
}
